/**
 * Created by luoyu on 17/8/2.
 */
var modalForm = {
    roomId: "",
    companyId: "",
    apartmentId: "",
    totalMoney: 0,
    planNumber: 0,
    latestCheckInTime: 0
};
var signPeriod = [], noTemplate = false,onlyRentRise=0;

/**
 * @desc 日期初始化
 */
function initPicker() {
    $('#time').mobiscroll().select({
        theme: 'mobiscroll',
        lang: 'zh',
        display: 'bottom',
        onSet: function (value, inset) {
            var mf = value.valueText;
            var val = "";
            // if(mf.indexOf("个月") > '-1'){
            //     val = Number(mf.replace("个月",""))
            // }else if(mf.indexOf("年")> '-1'){
            //     val = Number(mf.replace("年","")) * 12;
            // }
            $.each(signPeriod, function (i, o) {
                if (o.period_f == mf) {
                    val = o.contractPeriodId;
                }
            });
            $('#time_dummy').css('color', '#333');
            getCostData(val);
        }
    });
    $('#time_dummy').val('').attr('placeholder', '请选择签约周期')
    $('#coupon_picker').on('click', function () {
        $('#coupon_list').mobiscroll('show');
    });
    $('#sign_period').on('click', function () {
        $('#time').mobiscroll('show');
    });
    $('#coupon_list').mobiscroll().select({
        theme: 'mobiscroll',
        lang: 'zh',
        display: 'bottom'
    });
}

/**
 * @desc 初始化页面数据
 */
function initPage() {
    var param = commonJSCaller.getQuery();
    // modalForm = param;
    modalForm.roomId = param.room_id;
    modalForm.apartmentId = param.apartment_id;
    modalForm.companyId = param.company_id;
    $("#apt_title").text(param.title);
    $("#apt_room .iconfont").after(param.room_number);
    $("#apt_price .iconfont").after("¥" + param.rental + "/月");
    $("#apt_area .iconfont").after(param.area);
    getContractConf();
}

//返回日期
function formatDate(v) {
    var date = "";
    date = new Date(parseInt(v) * 1000).toLocaleString().replace(/:\d{1,2}$/, ' ').split(" ")[0];
    date = date.replace(/\//g, "-");
    if (date.charAt(date.length - 1) == ',') {
        date = date.substr(0, date.length - 1);
        if (date.split('-')[0].length != 4) {
            date = date.split('-');
            date = date[2] + '-' + date[0] + '-' + date[1]
        }
    }
    return date;
}

/**
 * @desc 最晚入住日期限制
 */
function initDatepicker(time) {
    $('#checkin_time').show();
    var now = new Date();
    var min = new Date(now.getFullYear(), now.getMonth(), now.getDate()),
        max = "";
    //判断今天是否早于2019/02/22。如果小于则是29，否则14
    var days = 14;
    if (now.getTime() < new Date('2019-02-22').getTime()) {
        days = 29
    }
    var minStamp = Date.parse(now) / 1000;
    var nowMaxStamp = minStamp + (days * 24 * 3600);
    console.log(nowMaxStamp);
    var nowMax = formatDate(nowMaxStamp).split("-");
    max = new Date(nowMax[0], nowMax[1] - 1, nowMax[2]);
    if (time) {
        var timeStamp = Date.parse(time) / 1000;
        var maxStamp = timeStamp + (days * 24 * 3600);
        var maxDate = formatDate(maxStamp).split("-");
        time = time.split("-");
        min = new Date(time[0], time[1] - 1, time[2]);
        max = new Date(maxDate[0], maxDate[1] - 1, maxDate[2]);
    }
    $('#checkin_time').mobiscroll().date({
        theme: 'mobiscroll',
        lang: 'zh',
        display: 'bottom',
        mode: 'scroller',
        dateFormat: "yyyy-mm-dd",
        min: min,
        max: max,
        minWidth: 50 * $('html').attr('data-dpr'),
        onSet: function (valueText, inst) {
            var time = valueText.valueText + ' 00:00:00';
            time = time.replace(/-/g, ':').replace(' ', ':');
            time = time.split(':');
            var timeTmp = new Date(time[0], (time[1] - 1), time[2], time[3], time[4], time[5]);
            modalForm.latestCheckInTime = timeTmp.getTime() / 1000;
            $('#checkin_time').css('color', '#333');
        }
    });
}

/**
 * 获取合同配置
 */
function getContractConf() {
    var para = {
        apartmentId: modalForm.apartmentId
    }
    $('.s-loading').addClass('show');
    var options = {
        name: "get_config",
        apiList: bookingAPI['apiList'],
        serviceName: "apartment",
        param: para,
        calSuc: function (json) {
            $('.s-loading').removeClass('show');
            console.log(json.data);
            if (json.data.contractConfigReq.length == 0 || json.data.contractPeriodReq.length == 0) {
                var txt = '预定';
                alert('该门店不支持' + txt + '业务，请联系管家。')
                return false;
            }
            $('#submit_order').removeClass('disabled');
            if (json.data.contractPeriodReq.length > 0) {
                initDatepicker(json.data.contractPeriodReq[0].nowTime);
                signPeriod = json.data.contractPeriodReq
                onlyRentRise = json.data.onlyRentRise || 0;
                genDropTemp(signPeriod);

            }
        },
        calFail: function () {
            $('.s-loading').removeClass('show');
            //失败处理
            initDatepicker();
        }
    }
    LeHttp.send(options)
}

/**
 *
 * @param {*} m 月份
 * @desc 签约周期显示转换
 */
function foramtPeriod(m) {
    var period_f = "";
    if (m < 6 || m > 6 && m < 12) {
        period_f = m + "个月";
    } else if (m == 6) {
        period_f = "半年";
    } else if (m >= 12) {
        if (m % 12 == 0) {
            period_f = m / 12 + "年";
        } else {
            period_f = m + "个月";
        }
    }
    return period_f;
}

/**
 *
 * @param {*} data
 * @desc 生成签约周期模板
 */
function genDropTemp(data) {
    $.each(data, function (i, o) {
        o.period_f = foramtPeriod(o.period);
    })

    var json = {
        data: data.sort(sortJ)
    }
    var tmp = template("period-temp", json);
    $("#time").html(tmp);
    initPicker();
    //   getCostData($("#time").val());
}

function sortJ(a, b) {
    return Number(a.period) - Number(b.period);
};


/**
 * @desc 获取费用科目
 */
function getCostData(id) {
    var discount = "";
    var month = "";
    $.each(signPeriod, function (i, o) {
        if (o.contractPeriodId == id) {
            discount = onlyRentRise == 0 ? o.discountScale : 1;
            month = o.period;
        }
    });

    modalForm.planNumber = month;

    //请求费用科目
    var para = {
        roomId: modalForm.roomId,
        ratio: discount,
        planNumber: month
    }
    commonJSCaller.showLoading()
    var options = {
        name: "get_cost",
        apiList: bookingAPI['apiList'],
        serviceName: "tenancy",
        param: para,
        calSuc: function (json) {
            commonJSCaller.hideLoading()
            var arr = [];
            arr.push(json.data);
            var dt = {
                data: arr
            }
            var temp = template("subject-temp", dt);
            $("#wgt-cost").html(temp);
            $("#total").text("¥" + json.data.deposit);
            modalForm.totalMoney = json.data.deposit;
        },
        calFail: function () {
            //失败处理
            commonJSCaller.hideLoading()
            $("#wgt-cost").html("");
        }
    }
    LeHttp.send(options)
}

/**
 * @desc 请求预定协议
 */
function getBookingAgrmt() {
    var param = {
        apartment_id: modalForm.apartmentId
    }
    ruleInvoker.getBookingRule(param, function (j) {
        if (typeof j == 'object') {
            //协议加载失败或者没有协议
            noTemplate = true
            $("#md-content").html('该门店尚未配置定金协议');
        } else {
            $("#md-content").html(j);
        }
    });
}

/**
 * @desc 预览协议
 */
function bindEvt() {
    //预览协议
    $(".preview").click(function () {
        $("#modal-5").addClass("md-show");
    });
    //提交预定单
    $("#submit_order").click(function () {
        if ($(this).hasClass('disabled')) return;
        var cur = $(this), text = cur.text();
        var para = modalForm;
        if (para.latestCheckInTime == 0) {
            alert('请选择日期')
            return false;
        }
        if ($('#time_dummy').val() == '') {
            alert('请选择签约周期')
            return false;
        }
        console.log(para);
        btnJSCaller.setBtnLoading(cur);
        var options = {
            name: "add_book",
            apiList: bookingAPI['apiList'],
            serviceName: "tenancy",
            param: para,
            datatype: "formdata",
            //成功执行
            calSuc: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                //跳转
                var url = "/rule.html";
                var p = {
                    type: 2,
                    apartment_id: modalForm.apartmentId,
                    contractBillId: json.data.contractBillId,
                    contractId: json.data.preordainId,
                    serviceCode: SCENECODE.preordain,
                    subjectInfoId: 1000000002
                };
                if (noTemplate) {
                    url = '/book_pay.html'
                }
                url = commonJSCaller.setQuery(url, p);
                commonJSCaller.jumpToWap(url, {clearRouteList: 1});
            },
            //错误执行
            calFail: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                alert(json.msg)
            }
        }
        LeHttp.send(options)
    });
}


function JsBridgeFinished() {
    initPage();
    bindEvt();
    commonJSCaller.getOnlineCardApartment();
    getBookingAgrmt();
}

