var bookingRomm = {
    isHoming: true,   // 失去焦点文档是否归位
    userId: "",
    apartmentId: "",
    sampleRoomRelationshipId: "",
    userName: "",
    userPhone: "",
    sendIng: false,
    isSendCode: false,
    // 是否显示验证码相关dom
    codeShow: function (bl) {
        if (bl) {
            $(".codeBtn").show();
            $(".codeInp").show();
        } else {
            $(".codeBtn").hide();
            $(".codeInp").hide();
        }
    },
    // 给日期空间绑定事件
    dateEvent: function () {
        var now = new Date();
        $('#sTime').mobiscroll().date({
            theme: 'mobiscroll',
            lang: 'zh',
            display: 'bottom',
            preset: 'date',
            mode: 'scroller',
            dateFormat: 'yy-mm-dd',
            min: new Date(now.getFullYear(), now.getMonth(), now.getDate())
        });
        $("#eTime").mobiscroll().scroller({
            theme: 'mobiscroll',
            display: 'bottom',
            lang: 'zh',
            mode: 'scroller',
            circular: false,
            showLabel: true,
            wheels: [
                [{
                    label: '',
                    data: [
                        "9:00-11:00",
                        "11:00-13:00",
                        "13:00-15:00",
                        "15:00-17:00",
                        "17:00-19:00",
                        "19:00-21:00"
                    ]
                }]
            ]
        });
    },
    // 给表单空间绑定事件
    inpEvent: function () {
        var _this = this;
        $(".inpFun").on("blur", function (e) {
            // blur时候是否将文档定位到原点
            _this.isHoming = true;
            setTimeout(function () {
                if (_this.isHoming) {
                    window.scrollTo(0, 0);
                }
            }, 10)

            // 判断手机号是否一样是否需要发送验证码
            if ($(e.target).attr("data-key") != "phone") return;
            var newPhone = $(e.target).val();
            if (!/^1[0-9]{10}$/.test(newPhone)) {
                alert("手机格式错误请重新填写！");
                return;
            }
            if (newPhone != _this.userPhone) {
                _this.isSendCode = true;
            } else {
                _this.isSendCode = false;
            }
            _this.codeShow(_this.isSendCode);


        })
        $(".inpFun").on("focus", function () {
            _this.isHoming = false;
        })
        $(".codeBtn").on("click", function () {
            var dom = this;
            var isDis = $(this).hasClass("disabled");
            if (isDis) return;
            var newPhone = $(".phone").val();
            if (!/^1[0-9]{10}$/.test(newPhone)) {
                alert("手机格式错误请重新填写！");
                return;
            }
            var timestamp = parseInt(new Date().getTime() / 1000);
            var params = {
                name: "getMessageCode",
                apiList: cardAPI['apiList'],
                serviceName: "client2",
                param: {
                    phone: newPhone,
                    timestamp: timestamp,
                    secret: $.md5("lefull" + timestamp * 2 + newPhone)
                },
                calSuc: function (json) {
                    console.log(json, 233);
                    _this.countDown(dom, 60);
                },
                calFail: function (err) {
                    alert("获取验证码失败")
                }

            }
            LeHttp.send(params)
        })
    },
    // 倒计时
    countDown: function (dom, t) {
        var time = t || 60;
        $(dom).text(time + "s");
        $(dom).addClass("disabled");
        var timer = setInterval(function () {
            if (time > 1) {
                time--;
                $(dom).text(time + "s");
            } else {
                clearInterval(timer);
                $(dom).text("发送验证码");
                $(dom).removeClass("disabled");
            }
        }, 1000)
    },
    // 提交
    sendBooking: function () {
        var _this = this;
        if (_this.sendIng) return;
        var must = ["name", "phone", "booking_time", "time_range"];
        var params = {
            apartment_id: _this.apartmentId, // app提供
            sample_room_relationship_id: _this.sampleRoomRelationshipId, // app提供
            user_id: _this.userId   // app提供
        };
        var inpList = $(".sendInp");
        for (var i = 0; i < inpList.length; i++) {
            var key = $(inpList[i]).attr("data-key");
            var value = $(inpList[i]).val();
            params[key] = value;
            if (must.indexOf(key) != -1 && value == "") {
                if (key == "name") {
                    alert("请输入姓名！");
                    return;
                } else if (key == "phone") {
                    alert("请输入电话号码！");
                    return;
                } else {
                    alert("请选择预约时间！");
                    return;
                }
            }
        }
        if (!/^1[0-9]{10}$/.test(params.phone)) {
            alert("手机格式错误请重新填写！");
            return;
        };
        if (params.auth_code == "" && params.phone != _this.userPhone) {
            alert("请输入验证码");
            return;
        }
        var options = {
            name: "sendBookingFun",
            apiList: cardAPI['apiList'],
            serviceName: "client2",
            param: params,
            calSuc: function (json) {
                commonJSCaller.checkBuryingPoint(function (res) {
                    let para = {
                        clientType: res.clientType,     //1:ios 2:android
                        appUUID: res.appUUID,           //ios:idfa android:IMEI
                        phoneType: res.phoneType,       //机型
                        phoneBrand: res.phoneBrand,     //手机品牌
                        refer: res.refer,               //外部跳入H5的url
                        channel: res.channel,           //app 下载渠道
                        page: "booking",                //点击按钮、来源页面 的标识-app自定义即可英文或者数字。
                        pageName: "预约看房",            //page的汉语标识
                        net: res.net,                  //wifi、3g、4g、5g、等
                        phoneNo: res.phoneNo,          //手机号
                        type: 6                        //接口请求类型 1激活 2登录 3注册 4页面停留时长 5房源详情 6线索点击量
                    }
                    //取参数请求后台埋点
                    var opt = {
                        name: "burypoint",
                        apiList: cardAPI['apiList'],
                        serviceName: "appprofile",
                        param: para,
                        calSuc: function (json) {
                            console.log(json)
                        },
                        calFail: function (err) {
                            console.log(err.message);
                        }
                    }
                    LeHttp.send(opt);
                });
                _this.sendingFun(false);
                alert("预约成功，管家会尽快联系您！");
                location.href = "lefull://navBack";
            },
            calFail: function (err) {
                _this.sendingFun(false);
                alert(err.message);
            }
        }
        _this.sendingFun(true);
        LeHttp.send(options);
    },
    // 提交中修改btn状态
    sendingFun(bl){
        var _this = this;
        if(bl){
            _this.sendIng = true;
            $("#submitBtn").addClass("disabled");
        }else{
            _this.sendIng = false;
            $("#submitBtn").removeClass("disabled");
        }
        
    },
    // 提交
    submitFun: function () {
        var _this = this;
        $("#submitBtn").on("click", function () {
            _this.sendBooking();
        })
    },
    // 获取地址栏参数
    getLocationSearch: function () {
        var _this = this;
        var search = window.location.search.substr(1);
        search = search.split("&");
        for (var i = 0; i < search.length; i++) {
            var item = search[i].split("=");
            this[item[0]] = item[1];
        }

        JSBridge.callHandler("checkUser", {}, function (res) {
            res = JSON.parse(res);
            _this.userName = res.userName;
            _this.userPhone = res.userPhone;
            _this.userId = res.tenantId;
            $(".userName").val(_this.userName);
            $(".phone").val(_this.userPhone);
        });

    },
    // 获取户型详情
    getSampleInfo: function () {
        var _this = this;
        var params = {
            name: "getSampleInfo",
            apiList: cardAPI['apiList'],
            serviceName: "client2",
            calSuc: function (json) {
                if (json.status == 1) {
                    var dt = json.data;
                    var sendDt = {
                        imgUrl: "https://lefull-www.lefull.cn/" + dt.cover_img,
                        infoName: dt.apartment_name,
                        address: dt.address,
                        tag: dt.tag.splice(0, 2)
                    }
                    if (_this.sampleRoomRelationshipId) {
                        
                        sendDt.money = dt.price_min + "-" + dt.price_max;
                    } else {
                        sendDt.money = dt.apartment_ex.price_min + "-" + dt.apartment_ex.price_max;
                    }
                    var tem = template("sampInfo", sendDt);
                    $(".roomDetail").append(tem);
                }
            },
            calFail: function (err) {
                alert('获取数据失败，请咨询管家')
                console.log(err)
            }
        }
        if (_this.sampleRoomRelationshipId) {
            params.name = "getSampleInfo";
            params.param = {
                sample_room_relationship_id: _this.sampleRoomRelationshipId
            }
        } else {
            params.name = "getApartmentInfo";
            params.param = {
                apartment_id: _this.apartmentId
            }
        }
        LeHttp.send(params);
    },
    init: function () {
        this.dateEvent();
        this.inpEvent();
        this.submitFun();
        this.getLocationSearch();
        this.codeShow(this.isSendCode);
        this.getSampleInfo();
    }
}

 function JsBridgeFinished() {
    bookingRomm.init();
 }



