/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: Jackk
 * @Last Modified time: 2019-12-26 15:19:05
 */
//全部城市门店数据
var cityAptList = [];
var config = {
    isSign: false,//是否签约
    isLogin: false,//是否登录
    isCard: false,//是否开通会员
    phone: '',
    name: '',
    id: "",
    avatar: ""
}
var benefits = []//所有权益
var currentBenefits = 0;//当前会员卡索引
var isExpire = false;//是否有优惠券并且未过期
var apartment = {
    id: '',
    name: ''
};


function initPage(res) {
    //判断当前门店id是否是开通了会员卡
    commonJSCaller.getOnlineCardApartment(function (hasCard, data) {
        if (hasCard) {
            //已开通
            apartment.id = res.apartmentId;
            apartment.name = res.apartmentName;
            var cityName = '';
            for (var i = 0; i < data.length; i++) {
                var o = data[i];
                for (var j = 0; j < o.apartmentList.length; j++) {
                    var z = o.apartmentList[j];
                    if (z.apartmentId == res.apartmentId) {
                        cityName = o.cityName;
                    }
                }
            };
            apartment.cityName = cityName;
        } else {
            //未开通
            apartment = {
                id: data[0].apartmentList[0].apartmentId,
                name: data[0].apartmentList[0].apartmentName,
                cityName: data[0].cityName
            }
        }

        //显示是否开通会员不同界面和请求
        if (!config.isCard || !config.isLogin) {
            //未开通会员，所以请求门店 新签租客权益内容，只有在用户未登录/未签约的情况下才显示。
            $('.noCard').show();
            cityAptList = data;
            initApartSelect();
            getList(0);
        } else {
            $('.hasCard').show();
            getList(1);
        }


        //未签约或者未登录
        // if ((!config.isSign || !config.isLogin) && !config.isCard) {
        //     $('.isNew').show();
        // }
    });
}

function initScroll() {
    var l = $("#scroller .card_scroll").length;
    if (l > 1) {
        $("#scroller").width(($("#scroller .card_scroll").outerWidth()+30) * l);
        var myScroll;
        myScroll = new IScroll('#wrapper', { snap: '.card_scroll', scrollY: false, scrollX: true, freeScroll: true ,click:true,tap: true});
        myScroll.on('scrollEnd', function () {
            var index = this.currentPage.pageX;
            $('.top_scroll span').removeClass('on').eq(index).addClass('on');
            currentBenefits = index;
            convertBenefit();
        })
    }
    var html = ''
    for (var i = 0; i < l; i++) {
        html += '<span class="animate"></span>'
    };
    $('.top_scroll').html(html);
    $('.top_scroll span').eq(0).addClass('on');
}

// 固定权益的拆分
function convertBenefit() {
    var data = benefits[currentBenefits];
    var o = [];
    for (var i = 0; i < data.fixedBenefitTemplate.length; i++) {
        data.fixedBenefitTemplate[i].benefitName = data.fixedBenefitTemplate[i].benefitName.substr(0, 6);
        data.fixedBenefitTemplate[i].benefitContent = data.fixedBenefitTemplate[i].benefitContent.substr(0, 12);
        if (i != 0) {
            o.push(data.fixedBenefitTemplate[i])
        }
    }
    if(!data.convert){
        for (var i = 0; i < data.limitBenefitTemplate.length; i++) {
            data.limitBenefitTemplate[i].endTime = LeUtil.Date.formatToDate(data.limitBenefitTemplate[i].endTime, 'yyyy.MM.dd');
        }
        for (var i = 0; i < data.outBenefitTemplate.length; i++) {
            data.outBenefitTemplate[i].endTime = LeUtil.Date.formatToDate(data.outBenefitTemplate[i].endTime, 'yyyy.MM.dd');
        }
    }
    
    // if (data.fixedBenefitTemplate.length == 1 || data.fixedBenefitTemplate.length > 2) {
    //     data.fone = data.fixedBenefitTemplate[0];
    //     data.fo = o
    // } else {
        data.fone = [];
        data.fo = data.fixedBenefitTemplate;
    // }
    if(data.limitBenefitTemplate.length > 4){
        data.limitBenefitTemplate= data.limitBenefitTemplate.slice(0,4);
    }
    var json = {
        data: data
    }
    var temp = template("list-temp", json);
    $('#benefit-temp').html(temp);

    //价格和名字
    // $('#price').html(data.price+'元/'+data.period+'天');
    $('#price').html(data.price+'/'+data.period+'天');
    $('#name').html(data.templateName);
    $('#templateId').val(data.vipCardTemplateId);

    if(!data.convert){
        data.convert = true;
    }
}

//初始化会员卡信息模板
function initCardsType() {
    var json = {
        data: benefits
    }
    var temp = template("card-temp", json);
    $('#scroller').html(temp);
    initScroll();
}

// 获取会员卡和权益信息
function getList(isVip) {
    commonJSCaller.showLoading();
    var name = 'findAllBenefits', param = { apartmentIds: apartment.id };
    if (isVip) {
        name = 'findVipCardAndBenefits';
        param = { tenantId: config.id || 82503 }
    }
    var options = {
        name: name,
        apiList: cardAPI['apiList'],
        serviceName: "vip",
        param: param,
        datatype: "formdata",
        //成功执行
        calSuc: function (res) {
            if (res.code == 200) {
                //权益
                if (res.data.length > 0 || res.data.fixedBenefitTemplate) {
                    if (isVip) {
                        res.data.imgUrl = 'https://lefull-app.lefull.cn/' + res.data.imgUrl
                        benefits = [res.data];
                    } else {
                        for (var i = 0; i < res.data.length; i++) {
                            res.data[i].imgUrl = 'https://lefull-app.lefull.cn/' + res.data[i].imgUrl
                        };
                        benefits = res.data;
                    }
                    initCardsType();
                    currentBenefits = 0;
                    convertBenefit();
                    $('.goDetail').click(function () { })
                    $('#checkAllBif').click(function () { })
                    $('.rule').click(function () { })
                    $('.immediate_btn').click(function () { })
                    $('.icon-fangkuang').click(function () { })
                }
                //已开通会员卡时
                if (res.data.isOpen == 1) {
                    res.data.endTime = LeUtil.Date.formatToDate(res.data.endTime, 'yyyy-MM-dd');
                    res.data.photo = config.avatar || returnAvatar(res.data.gender);
                    var json = {
                        data: res.data
                    }
                    var temp = template("info-temp", json);
                    $('#cardInfo').html(temp);
                    $('.myBif').click(function () { })
                    //已有会员卡 需要满足会员卡绑定了优惠券，并且在有效期内
                    // if (res.data.isExpire == 1) {
                    //     $('.isNew').show();
                    // }
                }
            } else {
            }
            commonJSCaller.hideLoading();
        },
        //错误执行
        calFail: function (json) {
            commonJSCaller.hideLoading();
            alert(json.msg);
        }
    }
    LeHttp.send(options)
}

function initInputWidth() {
    var val = $('#select_dummy').val().length;
    var l = Number(val) * 0.32 + 'rem';
    $('#select_dummy').css('width', l);
}

// 初始化select
function initApartSelect() {
    var json = {
        data: cityAptList
    }
    var temp = template("apartmentList", json);
    $("#select").html(temp);
    $('#select').val(apartment.id);

    $('#select').mobiscroll().select({
        theme: 'mobiscroll',
        lang: 'zh',
        mode: 'scroller',
        display: 'bottom',
        group: true,
        setText: '确定',
        cancelText: "取消",
        responsive: {
            small: {
                display: 'bubble'
            },
            medium: {
                touchUi: false
            }
        },
        onCancel() {
            $('#select_dummy').val(apartment.name);
            $('#select').val(apartment.id);
            initInputWidth();
        },
        onSet: function (valueText, inst) {
            var id = inst._wheelArray[1];
            var cityName = cityAptList[inst._wheelArray[0]].cityName;
            apartment.id = id;
            apartment.name = valueText.valueText;
            apartment.cityName = cityName;
            initInputWidth();
            getList(0);
        }
    });
    $('#select_dummy').val(apartment.name);
    initInputWidth();
}

// 节流函数
function eventHandler(func,wait) {
    var timeout;
    return function () {
        var context = this;
        var args = arguments;

        if (timeout) clearTimeout(timeout);

        var callNow = !timeout;
        timeout = setTimeout(function() {
            timeout = null;
        }, wait)

        if (callNow) func.apply(context, args)
    }
}


function bindEvt() {
    //点击开通
    $('#wrapper').on('click', '.immediate_btn', eventHandler(function () {
        var hasChecked = $('.icon-fangkuang').hasClass('icon-xuanzhongzhuangtai');
        if (hasChecked) {
            commonJSCaller.getTenantInfo(function (res) {
                config.isLogin = res.islogin;
                config.isSign = res.isSign ? true : false;
                config.isCard = res.isVip ? true : false;
                if (config.isLogin) {
                    $('.searchPerson,.md-card-tip p').hide();
                    $('.md-person').html('');
                    $('.md-card-input input').val('');
                    $("#modal-5").addClass("md-show");
                } else {
                    //跳转登录
                    JSBridge.callHandler('goLogin', {}, function () {
                        location.reload();
                    });
                }
            })
        } else {
            //没有勾选开通同意协议时弹窗
            alert('请先阅读并同意乐乎付费会员卡协议')
        }
    },800));
    //选中取消复选框
    $('#wrapper').on('click','.icon-fangkuang', function () {
        $(this).toggleClass('icon-xuanzhongzhuangtai');
        if ($(this).hasClass('icon-xuanzhongzhuangtai')) {
            $('.card-btn').removeClass('disabled');
        } else {
            $('.card-btn').addClass('disabled');
        }
    })
    //查看协议
    $(document).on('click','.rule', eventHandler(function () {
        var j = {
            url: lisa[ENV] + '/Account/protocol.html'
        }
        JSBridge.callHandler("jsNavgationH5", j);
    },800));
    //输入管家手机号
    $('.md-card-input input').on('focus', function () {
        $('.md-card-tip p').hide();
    });
    $('.md-card-input input').on('blur', function () {
        setTimeout(function () {
            window.scrollTo(0, 0)
        })
    })
    $('.md-card-input .card-btn').on('click', function () {
        getPersons();
    });
    //购买
    $('.pay').on('click', function () { })
    $(document).on('click', '.pay', function () {
        var val = $('.md-card-input input').val();
        var id = $(this).data('id') || '', name = $(this).data('name') || '';
        var _t = $(this);

        if ((!LeUtil.Reg.regPhone(val) && val !== '' && id) || $(this).hasClass('ajaxing')) {
            return false;
        }
        $(this).addClass('ajaxing');
        var p = {
            cityName: apartment.cityName,
            tenantId: config.id,
            tenantPhone: config.phone,
            tenantName: config.name,
            apartmentId: apartment.id,
            apartmentName: apartment.name,
            saleEmployeeId: id,
            saleEmployeeName: name,
            vipCardTemplateId: $('#templateId').val()
        }
        commonJSCaller.showLoading();
        var options = {
            name: "findVipCardAndBenefits",
            apiList: cardAPI['apiList'],
            serviceName: "vip",
            param: { tenantId: config.id },
            datatype: "formdata",
            //成功执行
            calSuc: function (res) {
                if (res.code == 200) {
                    var isOpen = res.data.isOpen;
                    if (isOpen == 1) {
                        //买了会员卡
                        alert('您已开通会员卡，无需重复购买')
                    } else {
                        //没买
                        payVipCard(p);
                    }
                } else {
                }
                setTimeout(function () {
                    _t.removeClass('ajaxing');
                }, 1000)
                commonJSCaller.hideLoading();
            },
            //错误执行
            calFail: function (json) {
                setTimeout(function () {
                    _t.removeClass('ajaxing');
                }, 1000)
                commonJSCaller.hideLoading();
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    });
    //已开通点击权益
    $(document).on('click', '.goDetail', eventHandler(function () {
        if ((!config.isCard || !config.isLogin) && !$(this).hasClass('noReg')) return;
        var u = $(this).data('url');
        var type = $(this).data('type');//1 链接  2 券码 3 优惠券
        var time = $(this).data('time');//time不为空，并且time大于当前时间则不能点击
        if (!time && time > (new Date().getTime() / 1000)) return;
        if (type == 0) return;//为绑定领取方式，不能点击
        if (type == 1) {
            var j = {
                url: u
            }
            JSBridge.callHandler("jsNavgationH5", j, function (res) { });
        } else if (type == 2) {
            //跳转权益
            commonJSCaller.jumpClientApp('BenefitsList', {}, function (res) { });
        } else {
            //跳转优惠券
            commonJSCaller.jumpClientApp('MyCouponList', {}, function (res) { });
        }
    },800));

    //跳转至全部限时权益
    $('#benefit-temp').on('click', '#checkAllBif',eventHandler(function () {
        var vipid = $(this).data('vipid');
        var params = {
            apartment_id : apartment.id,
            vip_id:vipid
        }
        var url = commonJSCaller.setQuery('/private.html',params)
        commonJSCaller.jumpToWap(url)
    },800))
     //跳转至我的权益
     $(document).on('click','.myBif',eventHandler(function() {
        commonJSCaller.jumpClientApp('BenefitsList', {}, function (res) { });
     },800))
     
    //点击新签租客权益
    // $('.isNew').on('click', function () {
    //     if (!config.isCard || !config.isLogin) return;
    //     commonJSCaller.jumpClientApp('MyCouponList', {}, function (res) { });
    // })
}

function returnAvatar(gender) {
    return gender == 1 ? 'https://lefull-app.lefull.cn/temp/avatar_placeholder_male@3x.png' : 'https://lefull-app.lefull.cn/temp/avatar_placeholder_female@3x.png';
}


function payVipCard(p) {
    commonJSCaller.showLoading();
    var options = {
        name: "payVipCardList",
        apiList: cardAPI['apiList'],
        serviceName: "vip",
        param: p,
        datatype: "formdata",
        //成功执行
        calSuc: function (res) {
            if (res.code == 200) {
                commonJSCaller.jumpClientApp('Cashier', { payURL: res.data.url }, function () {
                    //调APP的接口，确保点返回回到我的页面
                    JSBridge.callHandler('backMyPath', {}, function () { });
                    location.href = commonJSCaller.setQuery(location.href.split('?apartmentId')[0], { apartmentId: apartment.id, apartmentName: apartment.name, pay: 1 });
                });
            } else {
                alert(res.msg);
            }
            commonJSCaller.hideLoading();
        },
        //错误执行
        calFail: function (json) {
            commonJSCaller.hideLoading();
            alert(json.msg);
        }
    }
    LeHttp.send(options)
}

//匹配管家
function getPersons() {
    var val = $('.md-card-input input').val(), el = $('.md-card-input input')
    if (!LeUtil.Reg.regPhone(val)) {
        $('.md-card-tip p').show();
    } else {
        commonJSCaller.showLoading();
        var options = {
            name: "getEmployeeInfoForVipByPhone",
            apiList: cardAPI['apiList'],
            serviceName: "organization",
            param: { phone: val },
            datatype: "formdata",
            //成功执行
            calSuc: function (res) {
                if (res.code == 200) {
                    if (res.data != null) {
                        if (res.data.avatar.indexOf('static.dingtalk') <= -1) {
                            res.data.avatar = returnAvatar(res.data.gender);
                        }
                    }
                    var json = {
                        data: res.data
                    }
                    var temp = template("person-temp", json);
                    $('.md-person').html(temp);
                    $('.searchPerson').show();
                    $('.pay').on('click', function () { })
                } else {
                }
                commonJSCaller.hideLoading();
            },
            //错误执行
            calFail: function (json) {
                commonJSCaller.hideLoading();
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    }
}

function getLocation(call) {
    if (isInApp) {
        JSBridge.callHandler("startLocation", {}, function (res) {
            if (typeof res != 'object') {
                res = JSON.parse(res);
            }
            call(res);
        })
    } else {
        var res = { apartmentId: 10, apartmentName: "立水桥" }
        call(res);
    }
}
function JsBridgeFinished() {
    commonJSCaller.showLoading();
    commonJSCaller.getTenantInfo(function (res) {

        commonJSCaller.hideLoading();
        config.isLogin = res.islogin;
        config.isSign = res.isformalUser ? true : false;
        config.isCard = (res.isVip || commonJSCaller.getQuery().pay == 1) ? true : false;
        config.phone = res.userPhone;
        config.name = res.userName;
        config.id = res.tenantId;
        config.avatar = res.headImg

        initPage(commonJSCaller.getQuery());
        bindEvt();

        // alert('测试租客ID'+res.tenantId);
        // if ((!config.isLogin || !config.isSign) && !config.isCard && commonJSCaller.getQuery().fromh5!=1) {
        //     getLocation(function (res) {
        //         initPage(res);
        //         bindEvt();
        //     })
        // } else {
        //     initPage(commonJSCaller.getQuery());
        //     bindEvt();
        // }
    });


    // ruleInvoker.init(0, function (j) {
    //     if (typeof j == 'object') {
    //         //协议加载失败或者没有协议
    //         noTemplate = true
    //     }
    // });
}
