/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-02-26 11:23:26
 */
//提交参数
var modalForm = {
    apartment_id: "",
    vip_id: "",
}, config = {
    isLogin: false,//是否登录
    isCard: false,//是否开通会员
},noTemplate = false;

/**
 * @desc 页面获取全部权益列表
 */
function getPrivateList(params){
    commonJSCaller.showLoading();
    var para = {
        apartmentIds:modalForm.apartment_id || 1,
    };
    var options = {
        name: "findTemplateAndBenefits",
        apiList: privateAPI['apiList'],
        serviceName: "vip",
        param: para,
        calSuc: function (res) {
            commonJSCaller.hideLoading();
            if(res.code == 200){
                var targetVip = res.data.filter(item => item.vipCardTemplateId == modalForm.vip_id);
                var limitBenefitTemplate = (targetVip[0] && targetVip[0].limitBenefitTemplate) || [];
             if(limitBenefitTemplate.length > 0){
                limitBenefitTemplate.forEach(item => {
                    item.endTime = LeUtil.Date.formatToDate(item.endTime, 'yyyy.MM.dd');
                })
                let json = {
                    data:limitBenefitTemplate
                }
                    var temp = template("private-temp", json);
                     $('#privateList').html(temp);
                }else{
                    showNothing();
                }
            }
        },
        calFail: function (err) {
            commonJSCaller.hideLoading();
            showNothing()
        }
    }
    LeHttp.send(options)
}
// 节流函数
function eventHandler(func,wait) {
    var timeout;
    return function () {
        var context = this;
        var args = arguments;

        if (timeout) clearTimeout(timeout);

        var callNow = !timeout;
        timeout = setTimeout(function() {
            timeout = null;
        }, wait)

        if (callNow) func.apply(context, args)
    }
}
function showNothing(){
        $('.nothing').removeClass('disn');
}
function getTenantInfo(){
    commonJSCaller.getTenantInfo(function (res) {
        config.isLogin = res.islogin;
        config.isCard = res.isVip ? true : false;
    })
}
// 处理点击
function bindEvt() {
    $('#privateList').on('click','.privateItem',eventHandler(function(){
        if (!config.isCard || !config.isLogin) return;
        var u = $(this).data('url');
        var type = $(this).data('type');//1 链接  2 券码 3 优惠券
        var time = $(this).data('time');//time不为空，并且time大于当前时间则不能点击
        if (!time && time > (new Date().getTime() / 1000)) return;
        if (type == 0) return;//为绑定领取方式，不能点击
        if (type == 1) {
            var j = {
                url: u
            }
            JSBridge.callHandler("jsNavgationH5", j, function (res) { });
        } else if (type == 2) {
            //跳转权益
            commonJSCaller.jumpClientApp('BenefitsList', {}, function (res) { });
        } else {
            //跳转优惠券
            commonJSCaller.jumpClientApp('MyCouponList', {}, function (res) { });
        }
    },800))
   
}
/**
 * @desc 页面地址初始化
 */
function initPage() {
    var param = commonJSCaller.getQuery();

    if (param.period) {
        param.period = Number(param.period);
    }
    //页面传递参数赋值
    modalForm.apartment_id = param.apartment_id;
    modalForm.vip_id = param.vip_id;


    // modalForm.apartmentName = param.title.split("-")[0];//合并了只取门店名称


    //获取全部限时权益
    getPrivateList(param);
    getTenantInfo();
}

function JsBridgeFinished() {
    initPage();
    bindEvt();
    // commonJSCaller.getOnlineCardApartment();
    // ruleInvoker.init(0, function (j) {
    //     if (typeof j == 'object') {
    //         //协议加载失败或者没有协议
    //         noTemplate = true
    //     }
    // });
}
