/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-12-03 13:59:48
 */
//提交参数
var modalForm = {
    user_phone:''
}, noTemplate = false;
var status = 0;
var recordList = [],page = 1,lastpage = false, lock = false;
/**
 * @desc 页面获取预约列表
 */
function getRecordList(){
    var para = {
        phone:modalForm.user_phone,
        status:status,
        page: page,
        num: 6,
    };
    if (para.phone == "" || para.phone == undefined) {
        commonJSCaller.getTenantInfo(function (res) {
            para.phone = res.userPhone;
            modalForm.user_phone = res.userPhone;
            sendListReq(para);
        })
    } else {
        sendListReq(para);
    }
}
//发送列表请求
function sendListReq(para){
    var options = {
        name: "myBookingOrderList",
        apiList: reserveRecordAPI['apiList'],
        serviceName: "client2",
        param: para,
        calSuc: function (res) {
            commonJSCaller.hideLoading();
            if (res.status == 1 && res.data.length > 0) {
                res.data.forEach(item => {
                    item.arr = $.isEmptyObject(item.apartment_info) === true ? item.sample_room : item.apartment_info;
                    item.img = qiniuURL + item.arr.cover_img;
                    item.apartment_name = item.apartment_name == '' ? '' : item.apartment_name + '社区'
                    item.name = item.sample_room_name == '' ? item.apartment_name : item.sample_room_name;
                    item.tag = item.arr.tag || [];
                    if (item.arr.price_min) {
                        item.price_range = '￥' + item.arr.price_min + '-' + item.arr.price_max;
                    } else {
                        item.price_range = '暂无';
                    }
                })
                recordList = recordList.concat(res.data);
                let json = {
                    data: recordList
                }
                var temp = template("record-temp", json);
                $('#recodeList').html(temp);
                if (status == 1) {
                    $('#recodeList h3').addClass('c-grey');
                } else {
                    $('#recodeList h3').removeClass('c-grey');
                }
                if (recordList.length < 6) {
                    lastpage = true;
                } else {
                    $('.underLine').text('');
                }
                $('.nothing').addClass('disn');
            } else {
                if (res.data.length == 0) {
                    lastpage = true;
                }
                showNothing();
                if (page > 1) {
                    $('.underLine').text('已经到底了 ~');
                    $('.nothing').addClass('disn');
                } else {
                    $('#recodeList').html('');
                    $('.underLine').text('');
                    $('.nothing').removeClass('disn');
                }
            }
        },
        calFail: function (err) {
            commonJSCaller.hideLoading();
            showNothing()
            $('#recodeList').html('');
            $('.nothing').removeClass('disn');
            $('.underLine').text('');
        }
    }
    LeHttp.send(options)
}
// 判断是否显示无内容
function showNothing() {
    $('.nothing').removeClass('disn');
    var str = status == 1?'已':'未';
    $('.nothing p').text(`您没有任何${str}完成记录`);   
}
// 节流函数
function eventHandler(fn, delay,_this) {
    var timerId
    return function () {
        if (timerId) return
        timerId = setTimeout(function() {
            fn.call(_this)
            clearTimeout(timerId)
            timerId = null
        }, delay) 
    }
}
// 页面滚动置顶
function getScrollTop(){
    var scrollTop=0;
    if(document.documentElement&&document.documentElement.scrollTop){
        setTimeout (() =>{
            document.documentElement.scrollTop = 0;
        },10)
    }else if(document.body){
        scrollTop=document.body.scrollTop;
        
    }
        return scrollTop;
}

// 切换tab时重置
 function tabInit() {
    page = 1;
    lastpage = false;
    lock = true;
    getScrollTop();
    recordList = [];
 }

function handler() {
    // 点击tab跳转
    $('.reserve_record').on('click', '.tab', function (e) {
        var tabIndex = $(this).data('index');
        $(this).find('.swiper-text').addClass('swiper-text-active').end().siblings().find('.swiper-text').removeClass('swiper-text-active');
        $(this).find('.swiper-line').removeClass('disn').end().siblings().find('.swiper-line').addClass('disn');
        if(tabIndex != status){
            status = tabIndex;
            tabInit();
            commonJSCaller.showLoading();
            getRecordList();
        }
    })
    // 此处是滚动条到底部时候触发的事件，在这里写要加载的数据，或者是拉动滚动条的操作
    $(window).scroll(
        eventHandler(function() {
            var s = $(window).scrollTop(),
            h = $(window).height(),
            documentH = $(document).height();
        if(s > 0) {
            lock = false;
        }
        if ((s + h + 200) >= documentH && !lastpage && !lock) {
                page = page + 1;
                getRecordList();
        }
     },500,this));
}
/**
 * @desc 页面地址初始化
 */
function initPage() {
    var param = commonJSCaller.getQuery();

    // //页面传递参数赋值
    modalForm.user_phone = param.user_phone;


    // // modalForm.apartmentName = param.title.split("-")[0];//合并了只取门店名称

    // console.log(modalForm)

    //获取预约列表
    status = 0;
    commonJSCaller.showLoading();
    getRecordList();
}

function JsBridgeFinished() {
    initPage();
    handler();
    // bindEvt();
    // commonJSCaller.getOnlineCardApartment();
    // ruleInvoker.init(0, function (j) {
    //     if (typeof j == 'object') {
    //         //协议加载失败或者没有协议
    //         noTemplate = true
    //     }
    // });
}
