/*
 * @Author: Jack 
 * @Date: 2019-01-07 17:44:50 
 * @Last Modified by: Jack
 * @Last Modified time: 2019-02-22 17:50:33
 */
//定义服务
var serviceName = "tenancy";

var modalForm = {};//页面提交数据集合

//银行卡选择
function pickCard() {
    $("#card-manage").click(function () {
        //是否选中银行卡
        var cur = $(this),
            type = cur.attr("data-type");
        if (type != 0) {
            $("#slide-info").find(".active").removeClass("active");
            $("#slide-info a[data-type=" + type + "]").addClass("active");
        }
        $("#overlay").removeClass("none");
        $("#slide-info").addClass("anim");
    });
    $(".card-item").click(function () {
        var cur = $(this),
            type = cur.attr("data-type"),
            bank = cur.attr("data-bank"),
            card = cur.attr("data-card");
        if (!cur.hasClass("active")) {
            cur.parent().find(".active").removeClass("active");
            cur.addClass("active");
            var curBank = bank + " " + type + "(" + card + ")";
            $("#cur-bank").text(curBank);
            $("#card-manage").attr("data-type", type);
            $("#cancel").trigger("click");
        }
    });
    $("#overlay").click(function () {
        $("#cancel").trigger("click");
    })
    $("#cancel").click(function () {
        $("#overlay").addClass("none");
        $("#slide-info").addClass("slideInDown");
        setTimeout(function () {
            $("#slide-info").removeClass("slideInDown").removeClass("anim");
        }, 500)
    });
}

/**
 * @desc 请求解约协议
 */
function getSurrenderRule() {
    // document.addEventListener('touchmove', function (e) { e.preventDefault(); }, isPassive() ? {
    //     capture: false,
    //     passive: false
    // } : false);
    function initScroll() {
        var myScroll;
        myScroll = new IScroll('#wrapper', {scrollY: true, freeScroll: true});
    }

    var param = {
        apartmentId: modalForm.apartmentId,
        contractId: commonJSCaller.getQuery().contractId
    }
    ruleInvoker.getSurrenderRule(param, function (json) {
        $("#scroller").html(json);
        initScroll();
    });
}

//提交退租申请
function bindEvt() {
    $("#submit").click(function () {
        var cur = $(this), text = cur.text();
        if (!modalForm.bankCardId) {
            alert('请选择退款账户');
            return false;
        }
        btnJSCaller.setBtnLoading(cur);
        modalForm.contractId = commonJSCaller.getQuery().contractId;
        var name = "add_tenancyOrder";
        var options = {
            name: name,
            apiList: surrenderAPI['apiList'],
            serviceName: serviceName,
            datatype: "json",
            param: modalForm,
            //成功执行
            calSuc: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                console.log(json);
                var ops = {
                    title: "提示",
                    desc: "退租申请已提交，管家将尽快与您取得联系",
                    phone: ""
                }
                dialogContro.alertText(ops);
                // var url = "/surrender.html";
                // var p = {
                //     contractId:commonJSCaller.getQuery().contractId
                // };
                // url = commonJSCaller.setQuery(url,p);
                // commonJSCaller.jumpToWap(url);
            },
            //错误执行
            calFail: function (json) {
                btnJSCaller.resetBtnLoading(cur, text);
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    });
    //预览协议
    $(".preview").click(function () {
        $("#modal-5").addClass("md-show");
    });
    //选择退款账户
    $("#pic_account").click(function () {
        // var res = {
        //     reservedName:"李大峰",
        //     cardNo:"312312312312312312312312",
        //     bankCardName:"中国银行",
        //     bankBranch:"中国建设银行银丰路支行"
        // }
        //跳转原生银行卡界面
        commonJSCaller.jumpClientApp("BankCardList", "", function (res) {
            console.log(res);//银行卡id
            // res = JSON.parse(res);
            modalForm.bankCardId = res.cardId;
            $("#cur_text").text("修改退款账户");
            var json = {
                reservedName: res.reservedName,
                cardNo: res.cardNo,
                bankCardName: res.bankCardName,
                bankBranch: res.bankBranch
            }
            var bank_temp = template("bank-temp", json);
            $("#bank_info").html(bank_temp);
        })
    });
}

//退租周期选择
function initDate() {
    //退租日期选择 合同开始日期 至  今年 + 1年
    var beginTime = modalForm.beginTime.replace(/\//g, "-");
    beginTime = beginTime.split("-");
    var minY = beginTime[0];
    var minM = parseInt(beginTime[1]) - 1;
    var minD = beginTime[2];
    var now = new Date();
    $('#time').mobiscroll().date({
        theme: 'mobiscroll',
        lang: 'zh',
        display: 'bottom',
        mode: 'scroller',
        dateFormat: "yyyy-mm-dd",
        min: new Date(minY, minM, minD),
        max: new Date(now.getFullYear() + 1, 11, 31),
        minWidth: 50 * $('html').attr('data-dpr'),
        onSet: function (valueText, inst) {
            var time = valueText.valueText;
            modalForm.revokeTime = time;
            //请求更新科目数据
            getCostDetail(time);
            $("#time").css({
                color: "#333"
            })
        }
    });
}

//获取科目数据
function getCostDetail(revokeTime) {
    var name = "final_cost";
    var options = {
        name: name,
        apiList: surrenderAPI['apiList'],
        serviceName: serviceName,
        param: {
            contractId: commonJSCaller.getQuery().contractId,
            revokeTime: revokeTime
        },
        calSuc: function (json) {
            var dt = json.data;
            modalForm.subjectInfos = dt.subjectInfos;
            setCostData(dt);
        },
        calFail: function () {
        }
    }
    LeHttp.send(options)
}

/**
 *
 * @param {*} data
 * @desc 费用科目模板生成
 */
function setCostData(data) {
    var json = {
        data: data.subjectInfos
    }
    var temp = template("subject-temp", json);
    $("#subject-list").html(temp);
    if (data.subjectInfos.length > 0) {
        $("#subject-list").parent().show();
    } else {
        $("#subject-list").parent().hide();
    }
}

/**
 * @desc 获取退租详情
 */
function getTenantyOrder() {
    var name = "get_detail";
    var options = {
        name: name,
        apiList: surrenderAPI['apiList'],
        serviceName: serviceName,
        param: {
            contractId: commonJSCaller.getQuery().contractId
        },
        calSuc: function (json) {
            setPageData(json.data);
        },
        calFail: function (json) {
            alert(json.msg)
            //测试
            var dt = {
                "code": "200",
                "data": {
                    "apDeliveryId": "",
                    "apartment": "test通州北苑",
                    "apartmentId": 6,
                    "applyName": "王君哲",
                    "area": 20,
                    "beginTime": "2016/02/27",
                    "contractId": 0,
                    "createTime": "",
                    "endTime": "2017/02/26",
                    "imageUrls": [],
                    "indemnityReason": "",
                    "isIndemnity": 0,
                    "operationType": 0,
                    "paidTime": "2016/08/26",
                    "remark": "",
                    "rental": 2350,
                    "revokeReason": 0,
                    "revokeReasonStr": "",
                    "revokeStatus": 0,
                    "revokeStatusStr": "",
                    "revokeTime": "",
                    "revokeType": 0,
                    "revokeTypeStr": "",
                    "ridgepole": "2号楼",
                    "roomId": 146,
                    "roomNumber": "4071",
                    "roomTemplate": "",
                    "shouldPay": 0,
                    "subjectInfos": [],
                    "tenancyOrderId": "",
                    "total": 0
                },
                "msg": "成功",
                "requestSeqNo": "wt_null_1548325022851",
                "responseTime": "2019-01-25 09:22:05"
            }
            setPageData(dt.data);
        }
    }
    LeHttp.send(options)
}

/**
 *
 * @param {*} json
 * @Desc 页面数据赋值
 */
function setPageData(json) {
    modalForm = json;
    //门店信息
    $("#apt-name").text(json.apartment);
    $("#apt-room .iconfont").after(json.roomNumber);
    $("#apt-price .iconfont").after('¥' + json.rental + "/月");
    $("#apt-area .iconfont").after(json.area + "㎡");
    $("#checin_date").text(json.beginTime.replace(/\//g, "-"));
    $("#applyName").text(json.applyName);
    getSurrenderRule();
    initDate();
}

/**
 * 页面信息初始化
 */
function initPage() {
    getTenantyOrder();
    pickCard();
    bindEvt();
    dialogContro.init();
}

function JsBridgeFinished() {
    initPage();
}
