/*
 * @Author: Jack
 * @Date: 2019-01-08 19:58:32
 * @Last Modified by: Jack
 * @Last Modified time: 2019-11-29 14:51:09
 * @desc 公共方法集合
 */
//调试
var ENV = "test"; //dev | prod | test
//手动开启是否在app
var isInApp = false;

if (!isInApp) {
    setTimeout(function () {
        JsBridgeFinished();
    }, 1000)
}

//请求路径配置- java
var domain = {
    "dev": "https://api-dev.lefull.cn/",
    "test": "https://api-test.lefull.cn/",
    "prod": "https://api.lefull.cn/",
    "bat": "https://api-bat.lefull.cn/"
}
//请求路径配置- php
var lisa = {
    "dev": "https://elevenwap.lefull.cn/",
    "test": "https://wap-test.lefull.cn/",
    "prod": "https://m.lefull.cn",
    "bat": "https://wap-bat.lefull.cn/"
};

var client = {
    "dev": "https://lisaclient-dev.lefull.cn/",
    "test": "https://lisaclient-test.lefull.cn/",
    "prod": "https://lisaclient.lefull.cn",
    "bat": "https://lisaclient-bat.lefull.cn/"
};

var client2 = {
    "dev": "https://client-dev.lefull.cn",
    "test": "https://client-test.lefull.cn/",
    "prod": "https://client.lefull.cn",
    "bat": "https://client-bat.lefull.cn/"
}

var qiniu = {
    "test":"https://lefull-app.lefull.cn/",
    "bat":"https://lefull-app.lefull.cn/"
}

//服务
var service = {
    "tenancy": "tenancy",
    "apartment": "apartment-new",
    "marketing": "marketing",
    "micro": "accountplatform",
    "accountplatform": "accountplatform",
    "vip": "vip",
    "organization": "organization"
}


//场景配置
var SCENECODE = {
    "preordain": "preordain", //预定
    "contract_finance": "contract_finance", // '合同账单'
    "ious_finance": "ious_finance", // 分期账单
    "rent": "rent", // 入住
    "ious_rent": "ious_rent", // 入住并分期
    "surrender": "surrender", // 退租
    "reservation_surrender": "reservation_surrender", // 委托转租
    "electricity_recharge": "electricity_recharge", // 智能电表
    "activity_goods": "activity_goods", // 平台活动商品
    "renew": "renew", // 续租
    "ious_renew": "ious_renew", // 续租并分期
    "renewals": "renewals", // 杂费
    "switch_room": "switch_room", // 换房
    "gratuity": "gratuity", // 打赏
    "cleaning": "cleaning", // 保洁
    "canceled": "canceled", // 解除协议
    "tenant_auth": "tenant_auth", // 租客认证
    "aha_style": "aha_style" // 阿哈生活
}


//客户端方法调用
var commonJSCaller = {
    /**
     *
     * @param {*} key
     * @param {*} val
     * @desc 全屏加载
     */
    showLoading: function (key, val) {
        try {
            JSBridge.callHandler('showLoadAnimation', {}, function () { })
        } catch (e) {

        }
    },
    /**
     *
     * @param {*} key
     * @param {*} val
     * @desc 全屏加载
     */
    hideLoading: function (call) {
        try {
            JSBridge.callHandler('hideLoadAnimation', {}, function () {
                if (call) {
                    call();
                }
            })
        } catch (e) {
            if (call) {
                call();
            }
        }
    },
    /**
     *
     * @param {*} url
     * @desc 是否需要判断分次
     */
    isNeedSepPrice(apartmentId) {
        var ids = [78, 88, 93, 97, 98, 118, 133, 134, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 221, 222, 223, 224, 225, 226, 227, 228, 243, 245, 271, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, 282, 283, 284, 285];
        if (ids.indexOf(apartmentId) > -1) {
            return false
        } else {
            return true;
        }

    },
    /**
     *
     * @param {*} url
     * @desc 跳转wap页面地址
     */
    jumpToWap: function (url, param, call) {
        if (isInApp) {
            var req_url = '';
            if (url.indexOf('/') > -1) {
                req_url = 'view' + url
            } else {
                req_url = 'view/' + url
            }
            var j = {
                url: req_url
            };
            if (param) {
                if (param.clearRouteList) {
                    j.clearRouteList = param.clearRouteList
                }
                if (param.prePopUrl) {
                    j.prePopUrl = param.prePopUrl
                }
                //pop层级,prePopUrl,clearRouteList,prePopStack互斥
                if (param.prePopStack) {
                    j.prePopStack = param.prePopStack
                }
                ;
                //js返回跳转到历史记录 back:1
                if (param.back) {
                    j.back = 1

                }
            }

            JSBridge.callHandler("jsNavgationH5", j, function (res) {//res json对象
                if (res) {
                    res = JSON.parse(res)
                }
                ;
                if (call) {
                    call(res);
                }
                //res json对象{code:1,data:""},1:成功，data:返回数据
            });
        } else {
            location.href = '/view' + url;
        }
    },
    /**
     *
     * @param {*} url
     * @param {*} param
     * @desc 原生路由跳转
     */
    jumpClientApp: function (url, param, call) {
        var j = {
            url: url
        };
        if (param) {
            if (param.clearRouteList) {
                j.clearRouteList = param.clearRouteList
                delete param.clearRouteList
            }
            if (param.prePopUrl) {
                j.prePopUrl = param.prePopUrl
                delete param.prePopUrl
            }
            //pop层级,prePopUrl,clearRouteList,prePopStack互斥
            if (param.prePopStack) {
                j.prePopStack = param.prePopStack
                delete param.prePopStack
            }
            ;
            j.data = param;
        }
        JSBridge.callHandler("jsNavgationNative", j, function (res) {//res json对象
            if (res) {
                res = JSON.parse(res)
            }
            ;
            if (call) {
                call(res);
            }
            //res json对象{code:1,data:""},1:成功，data:返回数据
        });
    },
    /**
     *
     * @param {*} api
     * @param {*} param
     * @param {*} call
     * @desc 获取接口数据
     */
    getApiData: function (api, param, version, method, datatype, call) {
        JSBridge.callHandler("jsDataService", { //获取数据
            path: api, //接口名 除根域名之外的路径
            version: version,//1:lisa 2:domain 3:client 4:client2
            method: method,
            datatype: datatype,
            data: param //json字符串
        }, function (res) { //res json对象
            call(res);
        })
    },
    /**
     *
     * @param {*} key
     * @param {*} val
     * @desc 设置本地存储
     */
    setLocalStorage: function (key, val) {
        JSBridge.callHandler("jsStorage", {
            key: key, //唯一key
            data: val //json字符串
        })
    },
    /**
     *
     * @param {*} key
     * @desc 获取本地存储数据
     */
    getLocalStorage: function (key, call) {
        JSBridge.callHandler("jsReadStorage", {
            key: key //唯一key
        }, function (res) { //res json对象
            call(res);
        });
    },
    /**
     * @desc 获取地址栏获取参数
     */
    getQuery: function () {
        var url = location.search;
        var theRequest = new Object();
        if (url.indexOf("?") != -1) {
            var str = url.substr(1);
            strs = str.split("&");
            for (var i = 0; i < strs.length; i++) {
                theRequest[strs[i].split("=")[0]] = unescape(decodeURI(strs[i].split("=")[1]));
            }
        }
        return theRequest;
    },
    getVersion: function (serviceName) {
        switch (serviceName) {
            case 'lisa':
                return 1;
                break;
            case 'client':
                return 3;
                break;
            case 'client2':
                return 4;
                break;
            default:
                return 2;
                break;
        }
    },
    // 获取所有会员卡上线的门店
    getOnlineCardApartment: function (call) {
        var options = {
            name: "findOnlineApartment",
            apiList: cardAPI['apiList'],
            serviceName: "vip",
            param: {},
            datatype: "formdata",
            //成功执行
            calSuc: function (res) {
                if (res.code == 200) {
                    var id = commonJSCaller.getQuery().apartmentId || commonJSCaller.getQuery().apartment_id;
                    var hasCard = false;
                    var l = res.data;
                    var apartmentName = '';
                    for (var i = 0; i < l.length; i++) {
                        for (var j = 0; j < l[i].apartmentList.length; j++) {
                            var o = l[i].apartmentList[j];
                            if (id == o.apartmentId) {
                                if (call) {
                                    hasCard = true;
                                } else {
                                    apartmentName = o.apartmentName;
                                    commonJSCaller.getTenantInfo(function (v) {
                                        if (!v.isVip) {
                                            $('#card-open').attr('name', apartmentName)
                                            $('.card-header').show();
                                        }
                                    })
                                }
                            }
                        }
                    }
                    if (call) {
                        call(hasCard, l);
                    }
                }
            },
            //错误执行
            calFail: function (json) {
                alert(json.msg);
            }
        }
        LeHttp.send(options)
    },
    //app返回租客相关
    getTenantInfo: function (call) {
        if(isInApp){
            JSBridge.callHandler("checkUser", {}, function (res) {
                if(typeof res !='object'){
                    res = JSON.parse(res);
                }
                call(res);
            })
        }else{
            var res = { islogin: true, isSign: false, isVip: false };
            call(res);
        }
    },
    /**
     * @desc 跳转成功回调
     */
    paySuccessRoute: function (data, sc, fromlist, fromh5) {

        //3.14讨论全部跳首页
        commonJSCaller.jumpClientApp('Home', { clearRouteList: 1 });

        //1、来自账单列表的支付成功就回到账单列表
        //2、serviceCode:rent/renew && fromh5==1跳转物业交割单 (如果获取物业交割单id失败，则跳转首页)
        //  servoceCode:preordain && fromh5 == 1跳转首页
        //3、其他的都跳转首页
        // if (fromlist) {
        //     var url = "/contractList.html";
        // var p = {
        //     serviceCode: sc,
        //     contractId: fromlist //这里fromlist是传的初始serviceCode
        // };
        // url = commonJSCaller.setQuery(url, p);
        // commonJSCaller.jumpToWap(url, {clearRouteList: 1});
        //     commonJSCaller.jumpToWap(url, {back: 1});
        //     return false;
        // }
        // ;
        // if (fromh5 == 1) {
        //     //来自房号直签
        //     if (sc == 'preordain') {
        //         commonJSCaller.jumpClientApp('Home', {clearRouteList: 1});
        //     } else if (sc == 'rent' || sc == 'renew') {
        //         //跳转物业交割单
        //         payInvoker.getContractInfo(data, function (res) {
        //             if (res.status == 1) {
        //                 commonJSCaller.jumpClientApp('Checklist', {
        //                     deliveryId: res.data.delivery_id,
        //                     clearRouteList: 1
        //                 });
        //             } else {
        //                 commonJSCaller.jumpClientApp('Home', {clearRouteList: 1});
        //             }
        //         });
        //     }
        // } else {
        //     commonJSCaller.jumpClientApp('Home', {clearRouteList: 1});
        // }
    },
    /**
     * @desc json拼接地址栏获取参数
     */
    setQuery: function (url, json) {
        url = url + '?';
        for (var key in json) {
            url += key + '=' + json[key] + '&';
        }
        url = url.substring(0, url.length - 1);
        return url;
    },
    FloatAdd: function (arg1, arg2) {
        var r1, r2, m;
        try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
        try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
        m = Math.pow(10, Math.max(r1, r2))
        return (arg1 * m + arg2 * m) / m
    },

    //浮点数减法运算
    FloatSub: function (arg1, arg2) {
        var r1, r2, m, n;
        try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
        try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
        m = Math.pow(10, Math.max(r1, r2));
        //last modify by deeka
        //动态控制精度长度
        n = (r1 >= r2) ? r1 : r2;
        return ((arg1 * m - arg2 * m) / m).toFixed(n);
    }

}
//按钮加载模板
var temp = ' <span class="active-loading d-flex">' +
    '<i class="iconfont icon-loading"></i>' +
    '<b>加载中</b>' +
    '</span>';
//按钮Loading效果
var btnJSCaller = {
    /**
     *
     * @param {*} el
     * @param {*} text
     * @desc 显示按钮加载状态
     */
    setBtnLoading: function (el) {
        if (el.hasClass("is-loading")) return;
        el.addClass("is-loading").html(temp);
    },
    /**
     *
     * @param {*} el
     * @desc 重置按钮状态
     */
    resetBtnLoading: function (el, text) {
        $(el).removeClass("is-loading").html(text)
    }
}

//基本服务
var LeSeservice = {
    /**
     *
     * @param {*} name
     * @desc 获取对应请求api数据
     */
    getReqObj: function (name, apiList) {
        var apiItem = {};
        $.each(apiList, function (i, o) {
            if (name == o.name) {
                apiItem = o;
            }
        })
        return apiItem;
    }
};

//请求封装
var LeHttp = {
    /**
     * @desc 请求封装
     */
    send: function (options) {
        var req = LeSeservice.getReqObj(options.name, options.apiList); //获取对应api
        var reqUrl = this.getFullPath(options.serviceName) + req.path;
        var reqParam = options.param ? options.param : "";
        var method = req.method ? req.method : "get";
        if (!isInApp) {
            //浏览器
            $.ajax({
                url: reqUrl,
                data: reqParam,
                method: method,
                beforeSend: function (reqobj) {
                    reqobj.setRequestHeader('User-Id', "66272");
                    reqobj.setRequestHeader('keys', "testApi0001002");
                    //reqobj.setRequestHeader('App-Token', "FxL4E37Ku6J3Zluoqgprl7gyaUWgxNjINfsJRWXgOec89rpATlN3y8x4RPINyAYI");
                    if (options.datatype == "json") {
                        reqobj.setRequestHeader('Content-Type', "application/json;charset=utf-8");
                    }
                },
                success: function (json) {
                    if (options.serviceName == "lisa") {
                        options.calSuc(json);
                    } else {
                        if (json.code == 200 || json.status == 1) {
                            //成功
                            options.calSuc(json);
                        } else {
                            //失败
                            options.calFail(json);
                        }
                    }
                },
                timeout: 30000,//超时处理
                fail: function (json) {
                    console.log(json);
                    options.calFail(json);
                },
                error: function (json) {
                    //错误集合
                    var json = { msg: "发生错误，请稍后再试" }
                    options.calFail(json);
                }
            })
        } else {
            //app
            var appRequest = function () {
                var datatype = options.datatype || "urlencode";
                commonJSCaller.getApiData(((options.serviceName == 'lisa' || options.serviceName == 'client' || options.serviceName == 'client2') ? '' : (service[options.serviceName])) + req.path, reqParam, commonJSCaller.getVersion(options.serviceName), method, datatype, function (json) {
                    try {
                        json = JSON.parse(json);
                        if (options.serviceName == "lisa") {
                            options.calSuc(json);
                        } else {
                            if (json.code == 200 || json.status == 1) {
                                //成功
                                options.calSuc(json);
                            } else {
                                //失败
                                options.calFail(json);
                            }
                        }
                    } catch (e) {
                        options.calSuc(json);
                    }


                })
            };
            try {
                appRequest()
            } catch (e) {
                setTimeout(function () {
                    appRequest()
                }, 500)
            }
        }

    },
    /**
     *
     * @param {*} serviceName
     * @desc 获取请求完整路径
     */
    getFullPath: function (serviceName) {
        var path = "";
        if (serviceName == "lisa") {
            path = lisa[ENV];
        } else if (serviceName == 'client') {
            path = client[ENV]
        } else if (serviceName == 'client2') {
            path = client2[ENV]
        } else {
            path = domain[ENV] + service[serviceName];
        }
        return path
    }
}
//协议弹窗关闭
$(".md-close,.btn-agree,.md-overlay").click(function () {
    $(".md-modal").removeClass("md-show").hide();
    setTimeout(function () {
        $(".md-modal").show();
    }, 500)
});
//返回首页
$('.go-home').on('click', function () {
    //调用客户端返回
    commonJSCaller.jumpClientApp('Home', { clearRouteList: 1 });
});
//点击跳转乐乎会员
$('#card-open').parents('.card-header').on('click', function () {
    var p = {
        apartmentId: commonJSCaller.getQuery().apartment_id,
        apartmentName: $('#card-open').attr('name'),
        fromh5:1
    }
    var url = commonJSCaller.setQuery('/card_home.html', p);
    commonJSCaller.jumpToWap(url);
});

/**
 * @desc 确认框
 */
//模板
var confirmTemp = ' <div class="dialg dialog-confirm dialg-show">' +
    '<h3 class="dialg-h"><%=title%></h3>' +
    '<div class="dialg-c d-flex">' +
    '<%=desc%>' +
    ' </div>' +
    '<div class="dialg-f">' +
    '<div class="d-flex">' +
    // '<a href="tel:<%=phone%>" class="flex gray" id="dialog-btn-tel">联系管家</a>' +
    '<a href="javascript:;" class="flex" id="dialog-btn-sure">确定</a>' +
    '</div>' +
    '</div>' +
    '</div>' +
    '<div class="dialg-mask"></div>';
var dialogOptions = {};
var dialogContro = {
    init: function (options) {
        dialogOptions = options;
    },
    /**
     * @desc 绑定事件
     */
    bindEvt: function () {
        //联系管家
        $(".dialog-confirm").on("click", "#dialog-btn-tel", function () {
            console.log("联系管家，调用拨打电话接口");
        });
        $(".dialog-confirm").on("click", "#dialog-btn-sure", function () {
            var cur = $(this);
            $(".dialog-confirm").removeClass("dialg-show");
            //调用客户端返回
            commonJSCaller.jumpClientApp("Home", "");
        });
    },
    //退租
    alertText: function (opts) {
        var len = $(".dialog-confirm").length;
        if (len == 0) {
            var render = template.compile(confirmTemp);
            var json = {
                title: opts.title,
                desc: opts.desc,
                phone: opts.phone
            }
            var tp = render(json);
            $("body").append(tp);
            this.bindEvt();
        } else {
            $(".dialog-confirm").addClass("dialg-show");
        }
    }
}
//七牛地址
var qiniuURL = "https://lefull-www.lefull.cn/";

window.commonJSCaller = commonJSCaller;
window.btnJSCaller = btnJSCaller;
window.LeHttp = LeHttp;
window.LeSeservice = LeSeservice;
window.qiniuURL = qiniuURL;
window.dialogContro = dialogContro;
window.SCENECODE = SCENECODE;